function isElementHasHerf(node) {
    if (node.parentNode.tagName == "A") {
        return false;
    } else if (node.parentNode.tagName == "BLOCKQUOTE" || node.parentNode.tagName == "BODY" || node.parentNode.tagName == "TABLE") {
        return true;
    } else {
        return isElementHasHerf(node.parentNode)
    }
}

var patternEmail = /((\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+)|((13[0-9]|15[0-3]|15[7-9]|18[0-9]|145|147|15[5-6]|184)\d{8})|(0[0-9]{2,3}\-[0-9]{7,8})|(((([hH][tT][tT][pP][sS]?):\/\/)|((w{3}|W{3})(\.\w+)+\.[a-zA-Z]))[-a-zA-Z0-9+&@#/%?=~_|!:,.;]*))/g;
function notice() {
    log("notice_start.....")
    traverseNodes(document.body);
}

function display(textNode) {
    if (textNode.parentNode.tagName != "SCRIPT") { // 脚本内容中的不算
        if (isElementHasHerf(textNode)) {
            var data = textNode.data;
            var type = getStringType(data);
            if (type == 1) {
                var newstr = data.replace(patternEmail, "<font color=\"#55a0d2\" onClick=\"window.myfunction.showAction('$1')\">$1</font>");
                var span = document.createElement("span");
                span.innerHTML = newstr;
                textNode.parentNode.replaceChild(span, textNode)
            }
        }
    }
}

function getStringType(data) {
    var type = -1;
    if (patternEmail == null) {
        patternEmail = /((\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+)|((13[0-9]|15[0-3]|15[7-9]|18[0-9]|145|147|15[5-6]|184)\d{8})|(0[0-9]{2,3}\-[0-9]{7,8})|(((([hH][tT][tT][pP][sS]?):\/\/)|((w{3}|W{3})(\.\w+)+\.[a-zA-Z]))[-a-zA-Z0-9+&@#/%?=~_|!:,.;]*))/g;
    }
    patternEmail.compile(patternEmail);
    var match = patternEmail.test(data);
    if (match) {
        return 1;
    }
    return type;
}

function traverseNodes(node) {
    // 判断是否是元素节点
    try {
        if (node.nodeType == 1) {
            // 判断该元素节点是否有子节点
            if (node.hasChildNodes) {
                // 得到所有的子节点
                var sonnodes = node.childNodes;
                // 遍历所哟的子节点
                for (var i = 0; i < sonnodes.length; i++) {
                    // 得到具体的某个子节点
                    var sonnode = sonnodes.item(i);
                    // 递归遍历
                    traverseNodes(sonnode);
                }
            }
        } else if (node.nodeType == 3) {
            display(node);
        }
    } catch(e) {
        document.write(e);
    }
}

//更换webview内联附件的默认图标 jinhui 2017/07/04
window.replaceImagePath = function(){
    var imgs = document.getElementsByTagName("img");
    for (var i = 0; i < imgs.length; i++) {
        var src = window.myfunction.getImagePath(imgs[i].src);//js更换webview内联附件的默认图标 jinhui 2017/01/20
        imgs[i].src = src;
    }
}



function setOnClickImgTagListener() {
    log("setOnClickImgTagListener.....")
    var imgArray = document.getElementsByTagName('img');
    if(imgArray != null) {
      var imgSrcArray = new Array();
      for(var i = 0; i<imgArray.length;i++) {
            imgSrcArray[i] = imgArray[i].src;
            var img = imgArray[i];
            //log("addImgOnClickListener...tagName=null imgSrcArray_index_src="+imgSrcArray[i]);
                img.addEventListener("click",function () {
                       var parent = this.parentNode;
                       var tagName;
                       if(parent != null) {
                           tagName = parent.tagName;
                       }

                       if(tagName == null) {
                        log("addImgOnClickListener...tagName=null imgSrcArray="+imgSrcArray.length + "imgArray="+imgArray.length);
                        window.myfunction.openImage(this.src,imgSrcArray);
                       } else {
                        log("addImgOnClickListener...tagName="+tagName+" imgSrcArray="+imgSrcArray.length+ "imgArray="+imgArray.length)
                            if(tagName != 'A' && tagName != 'a') {
                             window.myfunction.openImage(this.src,imgSrcArray);
                            }
                       }
                    });
        }
    }
}


function getBodyScrollWidth() {
    var width = document.body.scrollWidth;
    log("getBodyScrollWidth...typeof="+typeof(width));
    window.myfunction.onBodyWidthCallback(width);
}



//打印日志
function log(msg){
    window.myfunction.log(msg);
}
