<script type = "text/javascript" >

	var screenWidth = window.screen.width;
    var maxWidth = screenWidth;
    var webViewWidth = window.myfunction.getWebViewWidth();
    var webViewMinHeight = 0;

//html解析完成时执行方法 jinhui 2017/07/04
function loadEvent(){
    //要把js放在<head>里
    log("************html解析完成*************");
    fitTableAndSign();
    setBodyMinHeight();
    retryFit = 3;
    scale();
}

//添加html解析完成onload事件监听，处理兼容问题 jinhui 2017/07/17
if (window.addEventListener) {//所有主流浏览器，除了 IE 8 及更早 IE版本
    log("************window.addEventListener*************");
    window.addEventListener("load", loadEvent);
} else if (window.attachEvent) {// IE 8 及更早 IE 版本
    log("************window.attachEvent*************");
    window.attachEvent("onload", loadEvent);
} else if (window.onload) {
    log("************window.onload*************");
    window.onload = loadEvent;
}

window.onresize = function(){
    setBodyMinHeight();
}

//设置body的minHeight,以防出现内容显示不全 jinhui 2017/07/06
function setBodyMinHeight(){
    var body = document.body;
    var clientHeight = parseInt(body.clientHeight);
    var bodyHeight = parseInt(getElementHeight(body));
    if(webViewMinHeight == 0){
        webViewMinHeight = parseInt(window.myfunction.getWebViewMinHeight() * (maxWidth / webViewWidth));
    }
    if(clientHeight < webViewMinHeight && webViewMinHeight > 0){
        try {
            log("body的高度小于webView的合适最小高度时,设置minHeight=webViewMinHeight");
            body.style.minHeight = webViewMinHeight;
        } catch (e){
            log(e);
        }
    } else if(clientHeight < bodyHeight){
        log("有可能出问题了！！！");
        try {
            log("设置一下body的minHeight,以防出现内容显示不全");
            var offset = bodyHeight - clientHeight;
            if(offset > 1000){
                offset = 1000;
            } else if(offset > 600){
                offset = 600;
            } else if(offset > 400){
                offset = 400;
            }
            body.style.minHeight = clientHeight + offset;
        } catch (e){
            log(e);
        }
    }
    log("大小变化***clientHeight:"+clientHeight+"*bodyHeight:"+bodyHeight+"*webViewMinHeight:"+webViewMinHeight);
}

function adjust() {
    setBodyStyle();

    var hrefs = document.getElementsByTagName("a");
    var patternHttp=/((((w{3}|W{3})(\.\w+)+\.[a-zA-Z]))[-a-zA-Z0-9+&@#/%?=~_|!:,.;]*)/g;
    for (var i = 0; i < hrefs.length; i++) {
        if(hrefs[i].href == "" && patternHttp.test(hrefs[i].text)){//如果网址超链接的url=""则重新设置以http开头
            hrefs[i].href = "http://"+hrefs[i].text;
        }
    }

    var blockquotes = document.getElementsByTagName("blockquote");
    for (var j = 0; j < blockquotes.length; j++) {
        blockquotes[j].style.width =   "100%";
        blockquotes[j].style.marginLeft = "0px";
    }

}

function getElementWidth(node) {
    if(node == null){
        return 0;
    }
    var width = 0;
    var w = 0;
    w = Number(node.width);
    if(!isNaN(w) && w > width){
        width = w;
    }
    if(node.style != null){
        w = Number(node.style.width);
        if(!isNaN(w) && w > width){
            width = w;
        }
        w = Number(node.style.minWidth);
        if(!isNaN(w) && w > width){
            width = w;
        }
    }
    try{
        if(node.getBoundingClientRect() != null){
            w = Number(node.getBoundingClientRect().width);
            if(!isNaN(w) && w > width){
                width = w;
            }
        }
    } catch(e){
        log(e);
    }

    if(isNaN(width)){
        width = 0;
    }
    return width;
}

function getElementHeight(node) {
    if(node == null){
        return 0;
    }
    var height = 0;
    var h = 0;
    h = Number(node.height);
    if(!isNaN(h) && h > height){
        height = h;
    }
    if(node.style != null){
        h = Number(node.style.height);
        if(!isNaN(h) && h > height){
            height = h;
        }
        h = Number(node.style.minHeight);
        if(!isNaN(h) && h > height){
            height = h;
        }
    }
    try{
        if(node.getBoundingClientRect() != null){
            h = Number(node.getBoundingClientRect().height);
            if(!isNaN(h) && h > height){
                height = h;
            }
        }
    } catch(e){
        log(e);
    }

    if(isNaN(height)){
        height = 0;
    }
    return height;
}

function isElementNeedReset(node) {
    if(node == null || node.parentNode == null){
        return true;
    }
    if (node.parentNode.tagName == "TD" || node.parentNode.tagName == "DT") {
        return false;
    } else if (node.parentNode.tagName == "TABLE") {
        return false;
    } else if (node.parentNode.tagName == "BODY") {
        return true;
    } else {
        return isElementNeedReset(node.parentNode)
    }
}

function isIMGElementNeedReset(node) {//判断图片是否不在表格中或是否是属于签名div的
    if (node.parentNode.id == "signContainer") {
        return false;
    } else if (node.parentNode.tagName == "TD" || node.parentNode.tagName == "DT") {
        return false;
    } else if (node.parentNode.tagName == "TABLE") {
        return false;
    } else if (node.parentNode.tagName == "BODY") {
        return true;
    } else {
        return isIMGElementNeedReset(node.parentNode)
    }
}

function isNoSignElementNeedReset(node) {//判断标签是否在表格中或是否是属于签名div的
    try {
        if(node == null || node.parentNode == null) {
            return true;
        } else if (node.id == "signTable") {
            return false;
        } else if (node.parentNode.id == "signContainer") {
            return false;
        } else if (node.parentNode.tagName == "TD" || node.parentNode.tagName == "DT") {
            return false;
        } else if (node.parentNode.tagName == "TABLE") {
            return false;
        } else if (node.parentNode.tagName == "BODY") {
            return true;
        } else {
            return isNoSignElementNeedReset(node.parentNode)
        }
    } catch(e) {
        return true;
    }

}

function isSignElementNeedReset(node) {//判断标签是否属于签名div
     if (node.parentNode.id == "signContainer") {
         //排除在签名div中的表格
         if(document.getElementById("dzmp_table") && document.getElementById("signInfoCode")){
             //标准的签名
             return true;
         }
         return false;
     } else if (node.parentNode.tagName == "TD" || node.parentNode.tagName == "DT") {
         return false;
     } else if (node.parentNode.tagName == "BODY") {
         return false;
     } else {
         return isSignElementNeedReset(node.parentNode)
     }
}

    function isElementHasHerf(node) {
    if (node.parentNode.tagName == "A") {
    return false;
    } else if (node.parentNode.tagName == "BLOCKQUOTE" || node.parentNode.tagName == "BODY" || node.parentNode.tagName == "TABLE") {
    return true;
    } else {
    return isElementHasHerf(node.parentNode)
    }
    }

    var patternEmail = /((\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+)|((13[0-9]|15[0-3]|15[7-9]|18[0-9]|145|147|15[5-6]|184)\d{8})|(0[0-9]{2,3}\-[0-9]{7,8})|(((([hH][tT][tT][pP][sS]?):\/\/)|((w{3}|W{3})(\.\w+)+\.[a-zA-Z]))[-a-zA-Z0-9+&@#/%?=~_|!:,.;]*))/g;

    function notice() {
    traverseNodes(document.body);
    }

    function display(textNode) {
    if (textNode.parentNode.tagName != "SCRIPT") {// 脚本内容中的不算
    if (isElementHasHerf(textNode)) {
    var data = textNode.data;
    var type = getStringType(data);
    if (type == 1) {
    var newstr = data.replace(patternEmail, "<font color=\"#55a0d2\" onClick=\"window.myfunction.showAction('$1')\">$1</font>");
    var span = document.createElement("span");
    span.innerHTML = newstr;
    textNode.parentNode.replaceChild(span, textNode)
    }
    }
    }
    }

    function getStringType(data) {
    var type = -1;
    if(patternEmail==null){
      patternEmail = /((\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+)|((13[0-9]|15[0-3]|15[7-9]|18[0-9]|145|147|15[5-6]|184)\d{8})|(0[0-9]{2,3}\-[0-9]{7,8})|(((([hH][tT][tT][pP][sS]?):\/\/)|((w{3}|W{3})(\.\w+)+\.[a-zA-Z]))[-a-zA-Z0-9+&@#/%?=~_|!:,.;]*))/g;
    }
    patternEmail.compile(patternEmail);
    var match = patternEmail.test(data);
    if (match) {
    return 1;
    }
    return type;
    }

    function traverseNodes(node) {
    // 判断是否是元素节点
    try {
    if (node.nodeType == 1) {
    // 判断该元素节点是否有子节点
    if (node.hasChildNodes) {
    // 得到所有的子节点
    var sonnodes = node.childNodes;
    // 遍历所哟的子节点
    for (var i = 0; i < sonnodes.length; i++) {
    // 得到具体的某个子节点
    var sonnode = sonnodes.item(i);
    // 递归遍历
    traverseNodes(sonnode);
    }
    }
    } else if (node.nodeType == 3) {
    display(node);
    }
    } catch(e) {
    document.write(e);
    }
    }

function reload() {
    adjust();
    notice();
    replaceImagePath();
}

function adjustFontSize(){
    var bodyele=document.getElementsByTagName('body')[0];
    var eles = bodyele.getElementsByTagName('*');
    if(eles.length>30){
     return;
    }
    var tableEle=document.getElementsByTagName('table');
    if(tableEle.length>0){
     return;
    }
    var fontEles=bodyele.getElementsByTagName('font');
    if (fontEles.length>0) {
      for (var i = 0; i < fontEles.length; i++) {
        var fontItem=fontEles[i];
        if (fontItem.size<2) {
          fontItem.size=2;
        };
      };
    };
    for (var i = 0; i < eles.length; i++) {
      var item=eles[i];
      if(item.style.fontSize!=''){
        var fontStr=item.style.fontSize;
        var index=fontStr.indexOf('p');
        if (index>0) {
          var fontInt=fontStr.substring(0,index);
          if (fontInt<12) {
            item.style.fontSize='12px';
          };
        };
      }
    };

  }

//获取节点的边距，防止缩放后超出屏幕宽度 jinhui 2017/07/04
function getPaddingWidth(node, isBody){
    try{
        var num = 0;
        if(isBody || node == null){
            return 8;
        }
        num += getLeftOrRightMarginWidth(node.style.padding, true);
        num += getLeftOrRightMarginWidth(node.style.paddingLeft, false);
        num += getLeftOrRightMarginWidth(node.style.paddingRight, false);

        num += getLeftOrRightMarginWidth(node.style.borderWidth, true);
        num += getLeftOrRightMarginWidth(node.style.borderLeftWidth, false);
        num += getLeftOrRightMarginWidth(node.style.borderRightWidth, false);

        num += getLeftOrRightMarginWidth(node.style.margin, true);
        num += getLeftOrRightMarginWidth(node.style.marginLeft, false);
        num += getLeftOrRightMarginWidth(node.style.marginRight, false);

        isBody = node.parentNode == null || node.tagName == document.body.tagName;
        return num + getPaddingWidth(node.parentNode, isBody);
    } catch(e) {
        log(e);
        return 8;
    }
}

//计算左右内外边距的宽度 jinhui 2017/08/25
function getLeftOrRightMarginWidth(styleValue, isDouble){//isDouble：padding、border、margin需要计算左右两边
    var match = getMatchNumbers(styleValue);
    var width = 0;
    if(match != null){
        if(match.length == 1){
            width += getNumberToString(match[0]) * (isDouble ? 2.0 : 1.0);
        } else if(match.length == 2 || match.length == 3){
            width += getNumberToString(match[1]) * (isDouble ? 2.0 : 1.0);
        } else if(match.length == 4){
            width += getNumberToString(match[0]) * 1.0;
            width += getNumberToString(match[3]) * 1.0;
        }
        if(styleValue.indexOf("em") > 0){//"em"的单位需要转换
            width = width * 16;
        }
    }
//    log("styleValue:"+styleValue+"***"+width);
    return width;
}

//字符串转为Number保留两位小数 jinhui 2017/08/25
function getNumberToString(numberStr){
    var num = Number(numberStr).toFixed(2);
    if(isNaN(num)){
        num = 0;
    }
    return num;
}

//jinhui 2017/08/25 正则表达式匹配整数或小数，返回一个数组，如：1px,2px,3em-->1 2 3
function getMatchNumbers(matchObj){
    if(matchObj == null){
        return null;
    }
    return matchObj.match(/(\d+(\.\d+)?)+/g);
}

var retryFit = 3;//缩放失败重试次数

function fitTableAndSign(){
    try {
        //表格与签名适配,返回表格或签名的最大宽度，
        //再使用webView.evaluateJavascript获取该返回值，
        //然后计算设置webView的缩放大小
        getMaxWidth();
        window.myfunction.fitTableAndSign(maxWidth);//由WebView进行整体缩放
    } catch (e) {
        if (retryFit-- > 0) {
            fitTableAndSign();
        }
        log(e);
    }
}

//获取最大表格或图片的宽度 jinhui 2017/07/04
function getMaxWidth(){

    setTableMinWidth();

    //表格适配
    var tables = document.getElementsByTagName("table");
    for (var i = 0; i < tables.length; i++) {
        var table = tables[i];
        var left = getPaddingWidth(table, false);
        var width = getElementWidth(table) + left;
        var isNeedReset = isNoSignElementNeedReset(table);
        if(isNeedReset && width > maxWidth){
            maxWidth = width;
        }
    }

    var blockquotes = document.getElementsByTagName("blockquote");
    for (var i = 0; i < blockquotes.length; i++) {
        var blockquote = blockquotes[i];
        var width = getElementWidth(blockquote);
        var isNeedReset = isElementNeedReset(blockquote);
        if(isNeedReset && width > maxWidth){
            maxWidth = width;
        }
    }

    var imgs = document.getElementsByTagName("IMG");
    for (var i = 0; i < imgs.length; i++) {
        var img = imgs[i];
        var left = getPaddingWidth(img, false);
        var width = getElementWidth(img) + left;
        var isNeedReset = isIMGElementNeedReset(img);
        if(isNeedReset && width > maxWidth){
            maxWidth = width;
        }
    }

    //签名适配
    var divs = document.getElementsByTagName("DIV");
    for (var i = 0; i < divs.length; i++) {
        var div = divs[i];
        if(div.id == 'signContainer'){
            setSignMinWidth(div);
        }
        var width = getElementWidth(div) + 10;
        var isNeedReset = isNoSignElementNeedReset(div);
        if(isNeedReset && width > maxWidth){
            maxWidth = width;
        }
    }

    if(maxWidth < screenWidth){
        maxWidth = screenWidth;
    }
    maxWidth = Math.round(maxWidth);//四舍五入，不能返回float类型
    log("screenWidth:"+screenWidth+"-maxWidth:"+maxWidth);
}

//特殊处理-139web的签名div无法获取正常宽度，所以用该div的最大的子节点的宽度设置为该签名的最小宽度 jinhui 2017/07/04
function setSignMinWidth(node){//设置签名最小宽度
    var signChildNodes = node.childNodes;
    var signMaxWidth = screenWidth * 0.90;//签名div有边距，90%防止超出屏幕宽度
    for(var j = 0; j < signChildNodes.length; j++){
        var signChildNode = signChildNodes[j];
        var width = getElementWidth(signChildNode);
        if(width > signMaxWidth){
            signMaxWidth = width;
        }
    }
    try{
        node.style.minWidth = signMaxWidth;
    } catch (e){
        log(e);
    }
}

//设置表格父节点最小宽度，特殊处理-多层表格时，获取外层表格宽度比内层表格宽度小，
//所以先获取内层表格的最大宽度设置为该外层表格的最小宽度 jinhui 2017/07/04
function setTableMinWidth(){
    var maxTableWidth = 0;
    var maxTable = null;
    var tables = document.getElementsByTagName("table");
    for (var i = 0; i < tables.length; i++) {
        var table = tables[i];
        var width = getElementWidth(table);
        if(width > maxTableWidth){
            maxTableWidth = width;
            maxTable = table;
        }
    }
    if(maxTableWidth > 0 && maxTable != null){
        try{
            var parent = maxTable.parentNode;
            while(parent.tagName != document.body.tagName){
                parent = parent.parentNode;
                if(parent.tagName == "TABLE"){
                    parent.style.minWidth = maxTableWidth;
                    break;
                }
            }
        } catch (e){
            log(e);
        }
    }
    return maxTableWidth;
}

//设置body的style jinhui 2017/07/04
function setBodyStyle(){
    var body = document.body;
    var width = maxWidth > webViewWidth ? webViewWidth : maxWidth;
    //使用maxWidth目的是使内容满屏适配 jinhui 2017/08/24
    body.style.width = maxWidth * 0.96; //96%处理边距上覆盖了半个字的问题
    body.style.overflowY = "hidden";//禁止WebView垂直滚动
    body.style.wordBreak = "break-all";
    body.style.wordWrap = "break-word";
}

//设置缩放比例 jinhui 2017/07/04
function scale(){
    try {
        log("缩放开始");
        //表格适配
        var tables = document.getElementsByTagName("table");
        for (var i = 0; i < tables.length; i++) {
            var table = tables[i];
            var left = getPaddingWidth(table, false);
            var width = getElementWidth(table) + left;
            var isNeedReset = isNoSignElementNeedReset(table);
            var isScale = table.getAttribute('scale');
            if(isScale){
                continue;
            }
            table.setAttribute('scale', 'true');
            if (isNeedReset) {
                var scale = getTableScale(width);
                table.style.zoom = scale;
                table.style.width = width - left;
            }
        }

        var imgs = document.getElementsByTagName("IMG");
        for (var i = 0; i < imgs.length; i++) {
            var img = imgs[i];
            var left = getPaddingWidth(img, false);
            var width = getElementWidth(img) + left;
            var isNeedReset = isIMGElementNeedReset(img);
            var isScale = img.getAttribute('scale');
            if(isScale){
                continue;
            }
            img.setAttribute('scale', 'true');
            if (isNeedReset) {
                var scale = getIMGScale(width);
                img.style.zoom = scale;
            }
        }

        //签名适配
        var divs = document.getElementsByTagName("DIV");
        for (var i = 0; i < divs.length; i++) {
            var signDiv = divs[i];
            if(signDiv.id != "signContainer"){
                continue;
            }
            var left = getPaddingWidth(signDiv, false);
            var width = getElementWidth(signDiv) + left;
            var isNeedReset = isElementNeedReset(signDiv);
            var isScale = signDiv.getAttribute('scale');
            if(isScale){
                continue;
            }
            signDiv.setAttribute('scale', 'true');
            if (isNeedReset) {
                var scale = getTableScale(width);
                signDiv.style.zoom = scale;
            }
        }
        log("缩放结束");
    } catch (e) {
         if (retryFit-- > 0) {
             scale();
         }
         log(e);
    }
}

//更换webview内联附件的默认图标 jinhui 2017/07/04
function replaceImagePath(){
    var imgs = document.getElementsByTagName("img");
    for (var i = 0; i < imgs.length; i++) {
        var src = window.myfunction.getImagePath(imgs[i].src);//js更换webview内联附件的默认图标 jinhui 2017/01/20
        imgs[i].src = src;
    }
}

//图片放大的倍数，图片宽度小于屏幕的1/3时使用1.5倍，大于1/3且小于1/2时不变 jinhui 2017/07/04
function getIMGScale(width) {
    var scale = 1.0;
    var w = maxWidth < webViewWidth ? maxWidth : webViewWidth;
    if (width < w / 3) {
//        scale = 1.5;
    } else if (width > w / 2) {
        scale = maxWidth / width;
    }
    return scale;
}

//表格放大的倍数，表格宽度小于屏幕的一半时使用1.5倍 jinhui 2017/07/04
function getTableScale(width){
    var w = maxWidth < webViewWidth ? maxWidth : webViewWidth;
    var scale = width > w / 2 ? (maxWidth / width) : 1.5;
    return scale;
}

//打印日志
function log(msg){
    window.myfunction.log(msg);
}
</script>
